Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1021)
@@ -4508,5 +4669,5 @@
 ViewCell *VspBspViewCellsManager::GetViewCell(const Vector3 &point, const bool active) const
 {
-	if (!mVspBspTree)
+	if (!ViewCellsConstructed())
 		return NULL;
 
@@ -4612,217 +4773,859 @@
 }
 
-void
-ViewCellsManager::ApplySpatialFilter(
-									 KdTree *kdTree,
-									 const float spatialFilterSize,
-									 ObjectPvs &pvs
-									 )
-{
-
-  // now compute a new Pvs by including also objects intersecting the extended boxes of
-  // visible objects
-
-  Intersectable::NewMail();
+
+
+/**************************************************************************/
+/*                   VspBspViewCellsManager implementation                */
+/**************************************************************************/
+
+
+VspOspViewCellsManager::VspOspViewCellsManager(VspTree *vspTree, OspTree *ospTree):
+ViewCellsManager(), mVspTree(vspTree), mOspTree(ospTree)
+{
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Construction.samples", mInitialSamples);
+	mVspTree->SetViewCellsManager(this);
+	mVspTree->mViewCellsTree = mViewCellsTree;
+}
+
+
+VspOspViewCellsManager::~VspOspViewCellsManager()
+{
+}
+
+
+float VspOspViewCellsManager::GetProbability(ViewCell *viewCell)
+{
+	return GetVolume(viewCell) / mViewSpaceBox.GetVolume();
+}
+
+
+void VspOspViewCellsManager::CollectViewCells()
+{
+	// view cells tree constructed
+	if (!ViewCellsTreeConstructed())
+	{
+		mVspTree->CollectViewCells(mViewCells, false);
+	}
+	else 
+	{	// we can use the view cells tree hierarchy to get the right set
+		mViewCellsTree->CollectBestViewCellSet(mViewCells, mNumActiveViewCells);
+	}
+}
+
+
+bool VspOspViewCellsManager::ViewCellsConstructed() const
+{
+	return mVspTree->GetRoot() != NULL;
+}
+
+
+ViewCell *VspOspViewCellsManager::GenerateViewCell(Mesh *mesh) const
+{
+	return new VspViewCell(mesh);
+}
+
+
+int VspOspViewCellsManager::ConstructSubdivision(const ObjectContainer &objects,
+												 const VssRayContainer &rays)
+{
+	mMaxPvsSize = (int)(mMaxPvsRatio * (float)objects.size());
+
+	// if view cells were already constructed
+	if (ViewCellsConstructed())
+		return 0;
+
+	int sampleContributions = 0;
+
+	VssRayContainer sampleRays;
+
+	int limit = min (mInitialSamples, (int)rays.size());
+
+	VssRayContainer constructionRays;
+	VssRayContainer savedRays;
+
+	Debug << "samples used for vsp bsp subdivision: " << mInitialSamples 
+		  << ", actual rays: " << (int)rays.size() << endl;
+
+	GetRaySets(rays, mInitialSamples, constructionRays, &savedRays);
+
+	Debug << "initial rays: " << (int)constructionRays.size() << endl;
+	Debug << "saved rays: " << (int)savedRays.size() << endl;
+
+	long startTime;
+
+#if TODO
+	if (1)
+		mVspTree->Construct(constructionRays, &mViewSpaceBox);
+	else
+		mVspTree->Construct(rays, &mViewSpaceBox);
+#endif
+	// collapse invalid regions
+	cout << "collapsing invalid tree regions ... ";
+	startTime = GetTime();
+	const int collapsedLeaves = mVspTree->CollapseTree();
+	Debug << "collapsed in " << TimeDiff(startTime, GetTime()) * 1e-3 
+		  << " seconds" << endl;
+
+    cout << "finished" << endl;
+
+	//-- stats
+	Debug << mVspTree->GetStatistics() << endl;
+
+	ResetViewCells();
+	Debug << "\nView cells after construction:\n" << mCurrentViewCellsStats << endl;
+
+
+	startTime = GetTime();
+
+	cout << "Computing remaining ray contributions ... ";
+
+	// recast rest of rays
+	if (SAMPLE_AFTER_SUBDIVISION)
+		ComputeSampleContributions(savedRays, true, false);
+
+	cout << "finished" << endl;
+
+	Debug << "Computed remaining ray contribution in " << TimeDiff(startTime, GetTime()) * 1e-3
+		  << " secs" << endl;
+
+	cout << "construction finished" << endl;
+
+	// real meshes are contructed at this stage
+	if (0)
+	{
+		cout << "finalizing view cells ... ";
+		FinalizeViewCells(true);
+		cout << "finished" << endl;
+	}
+
+	return sampleContributions;
+}
+
+
+int VspOspViewCellsManager::PostProcess(const ObjectContainer &objects,
+										const VssRayContainer &rays)
+{
+	if (!ViewCellsConstructed())
+	{
+		Debug << "postprocess error: no view cells constructed" << endl;
+		return 0;
+	}
+
+
+	// view cells already finished before post processing step 
+	// (i.e. because they were loaded)
+	if (mViewCellsFinished)
+	{
+		FinalizeViewCells(true);
+		EvaluateViewCellsStats();
+
+		return 0;
+	}
+
+	// check if new view cells turned invalid
+	int minPvs, maxPvs;
+
+	if (0)
+	{
+		minPvs = mMinPvsSize;
+		maxPvs = mMaxPvsSize;
+	}
+	else
+	{
+		minPvs = mPruneEmptyViewCells ? 1 : 0;
+		maxPvs = mMaxPvsSize;
+	}
+
+	Debug << "setting validity, min: " << minPvs << " max: " << maxPvs << endl;
+	cout << "setting validity, min: " << minPvs << " max: " << maxPvs << endl;
+	
+	SetValidity(minPvs, maxPvs); 
+
+	
+	// area has to be recomputed
+	mTotalAreaValid = false;
+	VssRayContainer postProcessRays;
+	GetRaySets(rays, mPostProcessSamples, postProcessRays);
+
+	Debug << "post processing using " << (int)postProcessRays.size() << " samples" << endl;
+
+
+	// should maybe be done here to allow merge working with area or volume
+	// and to correct the rendering statistics
+	if (0) FinalizeViewCells(false);
+		
+	// compute tree by merging the nodes of the spatial hierarchy
+	ViewCell *root = ConstructSpatialMergeTree(mVspTree->GetRoot());
+	mViewCellsTree->SetRoot(root);
+
+	// compute pvs
+	ObjectPvs pvs;
+	UpdatePvsForEvaluation(root, pvs);
+
+	
+	//-- render simulation after merge + refine
+	cout << "\nevaluating bsp view cells render time before compress ... ";
+	dynamic_cast<RenderSimulator *>(mRenderer)->RenderScene();
+	SimulationStatistics ss;
+	dynamic_cast<RenderSimulator *>(mRenderer)->GetStatistics(ss);
   
-  std::map<Intersectable *,
-	PvsData<Intersectable *>,
-	LtSample<Intersectable *> >::const_iterator oi;
-  
-  for (oi = pvs.mEntries.begin(); oi != pvs.mEntries.end(); ++oi) {
-	Intersectable *object = (*oi).first;
-	object->Mail();
-  }
-
-  ObjectPvs nPvs;
-  int nPvsSize=0;
-  // now go through the pvs again
-  for (oi = pvs.mEntries.begin(); oi != pvs.mEntries.end(); ++oi) {
-	Intersectable *object = (*oi).first;
-
-	//	Vector3 center = object->GetBox().Center();
-	//	AxisAlignedBox3 box(center - Vector3(spatialFilterSize/2),
-	//						center + Vector3(spatialFilterSize/2));
-
-	AxisAlignedBox3 box = object->GetBox();
-	box.Enlarge(Vector3(spatialFilterSize/2));
-
-	ObjectContainer objects;
-
-	// $$ warning collect objects takes only unmailed ones!
-	kdTree->CollectObjects(box,
-						   objects);
-	//	cout<<"collected objects="<<objects.size()<<endl;
-	ObjectContainer::const_iterator noi = objects.begin();
-	for (; noi != objects.end(); ++noi) {
-	  Intersectable *o = *noi;
-	  // $$ JB warning: pdfs are not correct at this point!
-	  nPvs.AddSample(o, Limits::Small);
-	  nPvsSize++;
-	}
-  }
-  //  cout<<"nPvs size = "<<nPvsSize<<endl;
-  pvs.Merge(nPvs);
-}
-
-void
-ViewCellsManager::ApplyFilter(ViewCell *viewCell,
-							  KdTree *kdTree,
-							  const float viewSpaceFilterSize,
-							  const float spatialFilterSize,
-							  ObjectPvs &pvs
-							  )
-{
-  // extend the pvs of the viewcell by pvs of its neighbors
-  // and apply spatial filter by including all neighbors of the objects
-  // in the pvs
-
-  // get all viewcells intersecting the viewSpaceFilterBox
-  // and compute the pvs union
-  
-  //Vector3 center = viewCell->GetBox().Center();
-  //  Vector3 center = m->mBox.Center();
-  
-  //  AxisAlignedBox3 box(center - Vector3(viewSpaceFilterSize/2),
-  //					  center + Vector3(viewSpaceFilterSize/2));
+
+	cout << " finished" << endl;
+	cout << ss << endl;
+	Debug << ss << endl;
+
+
+	//-- compression
+	if (ViewCellsTreeConstructed() && mCompressViewCells)
+	{
+		int pvsEntries = mViewCellsTree->GetNumPvsEntries(mViewCellsTree->GetRoot());
+		Debug << "number of entries before compress: " << pvsEntries << endl;
+
+		mViewCellsTree->SetViewCellsStorage(ViewCellsTree::COMPRESSED);
+
+		pvsEntries = mViewCellsTree->GetNumPvsEntries(mViewCellsTree->GetRoot());
+		Debug << "number of entries after compress: " << pvsEntries << endl;
+	}
+
+	// compute final meshes and volume / area
+	if (1) FinalizeViewCells(true);
+
+	// write view cells to disc
+	if (mExportViewCells)
+	{
+		char filename[100];
+		Environment::GetSingleton()->GetStringValue("ViewCells.filename", filename);
+		ExportViewCells(filename, mExportPvs, objects);
+	}
+
+
+	return 0;
+}
+
+
+int VspOspViewCellsManager::GetType() const
+{
+	return VSP_OSP;
+}
+
+
+ViewCell *VspOspViewCellsManager::ConstructSpatialMergeTree(VspNode *root)
+{
+	// terminate recursion
+	if (root->IsLeaf())
+	{
+		VspLeaf *leaf = dynamic_cast<VspLeaf *>(root);
+		leaf->GetViewCell()->SetMergeCost(0.0f);
+		return leaf->GetViewCell();
+	}
+	
+	
+	VspInterior *interior = dynamic_cast<VspInterior *>(root);
+	ViewCellInterior *viewCellInterior = new ViewCellInterior();
+		
+	// evaluate merge cost for priority traversal
+	float mergeCost = 1.0f / (float)root->mTimeStamp;
+	viewCellInterior->SetMergeCost(mergeCost);
+
+	float volume = 0;
+	
+	VspNode *front = interior->GetFront();
+	VspNode *back = interior->GetBack();
+
+
+	ObjectPvs frontPvs, backPvs;
+
+	//-- recursivly compute child hierarchies
+	ViewCell *backVc = ConstructSpatialMergeTree(back);
+	ViewCell *frontVc = ConstructSpatialMergeTree(front);
+
+
+	viewCellInterior->SetupChildLink(backVc);
+	viewCellInterior->SetupChildLink(frontVc);
+
+	volume += backVc->GetVolume();
+	volume += frontVc->GetVolume();	
+
+	viewCellInterior->SetVolume(volume);
+
+	return viewCellInterior;
+}
+
+
+
+void VspOspViewCellsManager::UpdatePvsForEvaluation(ViewCell *root, ObjectPvs &pvs)
+{
+	// terminate traversal
+	if (root->IsLeaf())
+	{
+		pvs = root->GetPvs();
+		SetScalarPvsSize(root, root->GetPvs().GetSize());
+		
+		return;
+	}
+	
+	//-- interior node => propagate pvs up
+	ViewCellInterior *interior = dynamic_cast<ViewCellInterior *>(root);
+	interior->GetPvs().Clear();
+	pvs.Clear();
+	vector<ObjectPvs> pvsList;
+
+	ViewCellContainer::const_iterator vit, vit_end = interior->mChildren.end();
+
+	for (vit = interior->mChildren.begin(); vit != vit_end; ++ vit)
+	{
+		ObjectPvs objPvs;
+		
+		//-- recursivly compute child pvss
+		UpdatePvsForEvaluation(*vit, objPvs);
+
+		// store pvs in vector
+		pvsList.push_back(objPvs);
+	}
+
+#if 1
+	Intersectable::NewMail();
+
+	//-- faster way of computing pvs:
+	//   construct merged pvs by adding 
+	//   and only those of the next pvs which were not mailed.
+	//   note: sumpdf is not correct!!
+	vector<ObjectPvs>::iterator oit = pvsList.begin();
+
+	for (vit = interior->mChildren.begin(); vit != vit_end; ++ vit, ++ oit)
+	{
+	    ObjectPvsMap::iterator pit, pit_end = (*oit).mEntries.end();
+	
+		for (pit = (*oit).mEntries.begin(); pit != pit_end; ++ pit)
+		{
+			Intersectable *intersect = (*pit).first;
+
+			if (!intersect->Mailed())
+			{
+				pvs.AddSample(intersect, (*pit).second.mSumPdf);
+				intersect->Mail();
+			}
+		}
+	}
+
+	// store pvs in this node
+	if (mViewCellsTree->ViewCellsStorage() == ViewCellsTree::PVS_IN_INTERIORS)
+	{
+		interior->SetPvs(pvs);
+	}
+	
+	// set new pvs size
+	SetScalarPvsSize(interior, pvs.GetSize());
+	
+
+#else
+
+	// really merge cells: slow put sumpdf is correct
+	viewCellInterior->GetPvs().Merge(backVc->GetPvs());
+	viewCellInterior->GetPvs().Merge(frontVc->GetPvs());
+#endif
+}
+
+
+bool VspOspViewCellsManager::GetViewPoint(Vector3 &viewPoint) const
+{
+	if (!ViewCellsConstructed())
+		return ViewCellsManager::GetViewPoint(viewPoint);
+
+	// TODO: set reasonable limit
+	const int limit = 20;
+
+	for (int i = 0; i < limit; ++ i)
+	{
+		viewPoint = mViewSpaceBox.GetRandomPoint();
+		if (mVspTree->ViewPointValid(viewPoint))
+		{
+			return true;
+		}
+	}
+
+	Debug << "failed to find valid view point, taking " << viewPoint << endl;
+	return false;
+}
+
+
+bool VspOspViewCellsManager::ViewPointValid(const Vector3 &viewPoint) const
+{
+  // $$JB -> implemented in viewcellsmanager (slower, but allows dynamic
+  // validy update in preprocessor for all managers)
+  return ViewCellsManager::ViewPointValid(viewPoint);
+
+  //	return mViewSpaceBox.IsInside(viewPoint) &&
+  //		   mVspBspTree->ViewPointValid(viewPoint);
+}
+
+
+void VspOspViewCellsManager::Visualize(const ObjectContainer &objects,
+									   const VssRayContainer &sampleRays)
+{
 	if (!ViewCellsConstructed())
 		return;
-
-  	if (viewSpaceFilterSize >= 0.0f) {
-
-  bool usePrVS = false;
-
-  if (!usePrVS) {
-	AxisAlignedBox3 box = GetViewCellBox(viewCell);
-	box.Enlarge(Vector3(viewSpaceFilterSize/2));
-	
-	ViewCellContainer viewCells;
-	ComputeBoxIntersections(box, viewCells);
-	
-  //  cout<<"box="<<box<<endl;
-	ViewCellContainer::const_iterator it = viewCells.begin(), it_end = viewCells.end();
-	
-	int i;
-	for (i=0; it != it_end; ++ it, ++ i) {
-	  	//cout<<"v"<<i<<" pvs="<<(*it)->GetPvs().mEntries.size()<<endl;
-	  pvs.Merge((*it)->GetPvs());
-	}
-  } else {
-	PrVs prvs;
-	AxisAlignedBox3 box = GetViewCellBox(viewCell);
-
-	//  mViewCellsManager->SetMaxFilterSize(1);
-	GetPrVS(box.Center(), prvs, viewSpaceFilterSize);
-	pvs = prvs.mViewCell->GetPvs();
-	DeleteLocalMergeTree(prvs.mViewCell);
-  }
-  } else
-	pvs = viewCell->GetPvs();
-   
-  if (spatialFilterSize >=0.0f)
-	ApplySpatialFilter(kdTree, spatialFilterSize, pvs);
-  
-}
-
-
-
-void
-ViewCellsManager::ApplyFilter(KdTree *kdTree,
-							  const float relViewSpaceFilterSize,
-							  const float relSpatialFilterSize
-							  )
-{
-
+#if TODO
+	VssRayContainer visRays;
+	GetRaySets(sampleRays, mVisualizationSamples, visRays);
+
+	//-- export view cells
+	if (1) 
+	{	// hack pvs
+		const int savedColorCode = mColorCode;
+		mColorCode = 1;
+	
+		Exporter *exporter = Exporter::GetExporter("final_view_cells.wrl");
+		
+		if (exporter)
+		{
+			cout << "exporting view cells after post process ... ";
+
+			if (0)
+			{
+				// export view space box
+				exporter->SetWireframe();
+				exporter->ExportBox(mViewSpaceBox);
+				exporter->SetFilled();
+			}
+
+			if (mExportGeometry)
+			{
+				exporter->ExportGeometry(objects);
+			}
+
+			// export rays
+			if (1 && mExportRays)
+			{
+				exporter->ExportRays(visRays, RgbColor(0, 1, 0));
+			}
+
+			//exporter->SetFilled();
+
+			// HACK: export without clip plane
+			const bool b = mUseClipPlaneForViz;
+			mUseClipPlaneForViz = false;
+
+			ExportViewCellsForViz(exporter);
+			
+			mUseClipPlaneForViz = b;
+			delete exporter;
+
+			cout << "finished" << endl;
+		}
+
+		mColorCode = savedColorCode;
+	}
+
+
+	if (0)
+	{
+		cout << "exporting depth map ... ";
+
+		Exporter *exporter = Exporter::GetExporter("depth_map.x3d");
+		if (exporter)
+		{
+			if (1)
+			{
+				exporter->SetWireframe();
+				exporter->ExportBox(mViewSpaceBox);
+				exporter->SetFilled();
+			}
+
+			if (mExportGeometry)
+			{
+				exporter->ExportGeometry(objects);
+			}
+
+			const int maxDepth = mVspBspTree->mBspStats.maxDepth;
+
+			ViewCellContainer::const_iterator vit, vit_end = mViewCells.end();
+
+			for (vit = mViewCells.begin(); vit != mViewCells.end(); ++ vit)
+			{
+				ViewCell *vc = *vit;
+
+				ViewCellContainer leaves;
+				mViewCellsTree->CollectLeaves(vc, leaves);
+
+				ViewCellContainer::const_iterator lit, lit_end = leaves.end();
+
+				for (lit = leaves.begin(); lit != lit_end; ++ lit)
+				{
+					BspLeaf *leaf = dynamic_cast<BspViewCell *>(*lit)->mLeaf;
+
+					Material m; 
+
+					float relDepth = (float)leaf->GetDepth() / (float)maxDepth;
+					m.mDiffuseColor.r = relDepth;
+					m.mDiffuseColor.g = 0.0f;
+					m.mDiffuseColor.b = 1.0f - relDepth;
+
+                    exporter->SetForcedMaterial(m);
+				
+
+					BspNodeGeometry geom;
+					mVspBspTree->ConstructGeometry(leaf, geom);
+					exporter->ExportPolygons(geom.GetPolys());
+				}
+			}
+
+			delete exporter;
+		}
+
+
+		cout << "finished" << endl;
+	}
+
+	//-- visualization of the BSP splits
+
+	bool exportSplits = false;
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.Visualization.exportSplits", exportSplits);
+
+	if (exportSplits)
+	{
+		cout << "exporting splits ... ";
+	 	ExportSplits(objects, visRays);
+		cout << "finished" << endl;
+	}
+
+	//-- export single view cells
+	ExportBspPvs(objects, visRays);
+#endif
+}
+
+
+void VspOspViewCellsManager::ExportBspPvs(const ObjectContainer &objects,
+										  const VssRayContainer &rays)
+{
+	int leafOut;
+	Environment::GetSingleton()->GetIntValue("ViewCells.Visualization.maxOutput", leafOut);
+
+	ViewCell::NewMail();
+
+	cout << "visualization using " << (int)rays.size() << " samples" << endl;
+	Debug << "visualization using " << (int)rays.size() << " samples" << endl;
+	Debug << "\nOutput view cells: " << endl;
+
+	const bool sortViewCells = true;
+
+	// sort view cells to visualize the largest view cells
+	if (sortViewCells)
+	{
+		//stable_sort(mViewCells.begin(), mViewCells.end(), ViewCell::SmallerPvs);
+		stable_sort(mViewCells.begin(), mViewCells.end(), ViewCell::LargerRenderCost);
+	}
+
+	int limit = min(leafOut, (int)mViewCells.size());
+
+	int raysOut = 0;
+
+	//-- some rays for output
+	for (int i = 0; i < limit; ++ i)
+	{
+		cout << "creating output for view cell " << i << " ... ";
+
+		ViewCell *vc;
+	
+		if (sortViewCells) // largest view cell pvs first
+			vc = mViewCells[i];
+		else
+			vc = mViewCells[(int)RandomValue(0, (float)mViewCells.size() - 1)];
+
+		ObjectPvs pvs;
+		mViewCellsTree->GetPvs(vc, pvs);
+
+		//bspLeaves[j]->Mail();
+		char s[64]; sprintf(s, "bsp-pvs%04d.wrl", i);
+		Exporter *exporter = Exporter::GetExporter(s);
+		
+		Debug << i << ": pvs size=" << (int)mViewCellsTree->GetPvsSize(vc) << endl;
+
+		//-- export the sample rays
+		if (mExportRays)
+		{
+			// output rays stored with the view cells during subdivision
+			if (0)
+			{
+				VssRayContainer vcRays;
+                VssRayContainer collectRays;
+
+				raysOut = min((int)rays.size(), 100);
+
+				// collect intial view cells
+				ViewCellContainer leaves;
+				mViewCellsTree->CollectLeaves(vc, leaves);
+
+				ViewCellContainer::const_iterator vit, vit_end = leaves.end();
+       
+				for (vit = leaves.begin(); vit != vit_end; ++ vit)
+				{
+					BspLeaf *vcLeaf = dynamic_cast<BspViewCell *>(*vit)->mLeaf;
+				
+					VssRayContainer::const_iterator rit, rit_end = vcLeaf->mVssRays.end();
+
+					for (rit = vcLeaf->mVssRays.begin(); rit != rit_end; ++ rit)
+					{
+						collectRays.push_back(*rit);
+					}
+				}
+
+				VssRayContainer::const_iterator rit, rit_end = collectRays.end();
+
+				for (rit = collectRays.begin(); rit != rit_end; ++ rit)
+				{
+					float p = RandomValue(0.0f, (float)collectRays.size());
+			
+					if (p < raysOut)
+						vcRays.push_back(*rit);
+				}
+
+				//-- export rays piercing this view cell
+				exporter->ExportRays(vcRays, RgbColor(1, 1, 1));
+			}
+		
+			// associate new rays with output view cell
+			if (1)
+			{
+				VssRayContainer vcRays;
+				raysOut = min((int)rays.size(), mVisualizationSamples);
+
+				// check whether we can add the current ray to the output rays
+				for (int k = 0; k < raysOut; ++ k)
+				{
+					VssRay *ray = rays[k];
+					for	(int j = 0; j < (int)ray->mViewCells.size(); ++ j)
+					{
+						ViewCell *rayvc = ray->mViewCells[j];
+	
+						if (rayvc == vc)
+							vcRays.push_back(ray);
+					}
+				}	
+				
+				//-- export rays piercing this view cell
+				exporter->ExportRays(vcRays, RgbColor(1, 1, 0));
+			}
+
+		}
+		
+
+		//-- export view cell geometry
+		exporter->SetWireframe();
+
+		Material m;//= RandomMaterial();
+		m.mDiffuseColor = RgbColor(0, 1, 0);
+		exporter->SetForcedMaterial(m);
+
+		ExportViewCellGeometry(exporter, vc);
+	
+		exporter->SetFilled();
+
+
+		//-- export pvs
+		if (1)
+		{
+			ObjectPvsMap::const_iterator oit,
+				oit_end = pvs.mEntries.end();
+
+			Intersectable::NewMail();
+
+			// output PVS of view cell
+			for (oit = pvs.mEntries.begin(); oit != oit_end; ++ oit)
+			{		
+				Intersectable *intersect = (*oit).first;
+
+				if (!intersect->Mailed())
+				{
+					m = RandomMaterial();
+					exporter->SetForcedMaterial(m);
+
+					exporter->ExportIntersectable(intersect);
+					intersect->Mail();
+				}
+			}
+		}
+		
+		if (0)
+		{   // export scene geometry
+			m.mDiffuseColor = RgbColor(1, 0, 0);
+			exporter->SetForcedMaterial(m);
+
+			exporter->ExportGeometry(objects);
+		}
+
+		DEL_PTR(exporter);
+		cout << "finished" << endl;
+	}
+
+	Debug << endl;
+}
+
+
+int VspOspViewCellsManager::ComputeBoxIntersections(const AxisAlignedBox3 &box, 
+													ViewCellContainer &viewCells) const
+{
+	return mVspTree->ComputeBoxIntersections(box, viewCells);
+}
+
+
+int VspOspViewCellsManager::CastLineSegment(const Vector3 &origin,
+											const Vector3 &termination,
+											ViewCellContainer &viewcells)
+{
+	return mVspTree->CastLineSegment(origin, termination, viewcells);
+}
+
+
+void VspOspViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
+                                                    ViewCell *vc,
+													const Plane3 *clipPlane) const
+{
+	// matt: TODO
+}
+
+
+bool VspOspViewCellsManager::ExportViewCells(const string filename, 
+											 const bool exportPvs, 
+											 const ObjectContainer &objects)
+{
+	if (!ViewCellsConstructed() || !ViewCellsTreeConstructed())
+		return false;
+
+	cout << "exporting view cells to xml ... ";
+	
+#if ZIPPED_VIEWCELLS
+	ogzstream stream(filename.c_str());
+#else
+	std::ofstream stream(filename.c_str());
+#endif
+
+	// for output we need unique ids for each view cell
+	CreateUniqueViewCellIds();
+
+	stream << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"<<endl;
+	stream << "<VisibilitySolution>" << endl;
+
+	//-- the view space bounding box
+	stream << "<ViewSpaceBox" 
+		   << " min=\"" << mViewSpaceBox.Min().x << " " << mViewSpaceBox.Min().y << " " << mViewSpaceBox.Min().z << "\""
+		   << " max=\"" << mViewSpaceBox.Max().x << " " << mViewSpaceBox.Max().y << " " << mViewSpaceBox.Max().z << "\" />" << endl;
+
+	
+	//-- export bounding boxes
+	stream << "<BoundingBoxes>" << endl;
+
+	ObjectContainer::const_iterator oit, oit_end = objects.end();
+
+	for (oit = objects.begin(); oit != oit_end; ++ oit)
+	{
+			MeshInstance *mi = dynamic_cast<MeshInstance *>(*oit);
+			const AxisAlignedBox3 box = mi->GetBox();
+
+			//-- the bounding boxes
+			stream << "<BoundingBox" << " id=\"" << mi->GetId() << "\""
+				   << " min=\"" << box.Min().x << " " << box.Min().y << " " << box.Min().z << "\""
+				   << " max=\"" << box.Max().x << " " << box.Max().y << " " << box.Max().z << "\" />" << endl;
+	}
+
+	stream << "</BoundingBoxes>" << endl;
+
+
+	//-- export the view cells and the pvs
+	stream << "<HierarchyType name=\"vspBspTree\" />" << endl;
+
+	const int numViewCells = mCurrentViewCellsStats.viewCells;
+
+	stream << "<ViewCells number=\"" << numViewCells << "\" >" << endl;
+	
+	mViewCellsTree->Export(stream, exportPvs);
+
+	stream << "</ViewCells>" << endl;
+
+
+	//-- export the spatial hierarchy
+	
+	// the type of the view cells hierarchy
+	stream << "<Hierarchy>" << endl;
+	mVspTree->Export(stream);
+	stream << endl << "</Hierarchy>" << endl;
+
+	stream << "</VisibilitySolution>" << endl;
+
+
+	stream.close();
+	cout << "finished" << endl;
+
+	return true;
+}
+
+
+
+ViewCell *VspOspViewCellsManager::GetViewCell(const Vector3 &point, const bool active) const
+{
 	if (!ViewCellsConstructed())
-		return;
-
-  ViewCellContainer::const_iterator it, it_end = mViewCells.end();
-
-  ObjectPvs *newPvs;
-  newPvs = new ObjectPvs[mViewCells.size()];
-
-  float viewSpaceFilterSize = Magnitude(mViewSpaceBox.Size())*relViewSpaceFilterSize;
-  float spatialFilterSize = Magnitude(kdTree->GetBox().Size())*relSpatialFilterSize;
-  
-  int i;
-  for (i=0, it = mViewCells.begin(); it != it_end; ++ it, ++ i) {
-	ApplyFilter(*it,
-				kdTree,
-				viewSpaceFilterSize,
-				spatialFilterSize,
-				newPvs[i]
-				);
-  }
-
-  // now replace all pvss
-  for (i = 0, it = mViewCells.begin(); it != it_end; ++ it, ++ i) {
-	    
-	ObjectPvs &pvs = (*it)->GetPvs();
-	pvs.Clear();
-	pvs = newPvs[i];
-	newPvs[i].Clear();
-  }
-  
-  delete [] newPvs;
-}
-
-void VspBspViewCellsManager::TestFilter(const ObjectContainer &objects)
-{
-	Exporter *exporter = Exporter::GetExporter("filter.x3d");
-
-	Vector3 bsize = mViewSpaceBox.Size();
-	const Vector3 viewPoint(mViewSpaceBox.Center());
-	float w = Magnitude(mViewSpaceBox.Size()) * mFilterWidth;
-	const Vector3 width = Vector3(w);
-	
-	PrVs testPrVs;
-	
-	if (exporter)
-	{
-		ViewCellContainer viewCells;
-	
-        const AxisAlignedBox3 tbox = GetFilterBBox(viewPoint, mFilterWidth);
-
-		GetPrVS(viewPoint, testPrVs, GetFilterWidth());
-
-		exporter->SetWireframe();
-
-		exporter->SetForcedMaterial(RgbColor(1,1,1));
-		exporter->ExportBox(tbox);
-		
-		exporter->SetFilled();
-
-		exporter->SetForcedMaterial(RgbColor(0,1,0));
-		ExportViewCellGeometry(exporter, GetViewCell(viewPoint));
-
-		//exporter->ResetForcedMaterial();
-		exporter->SetForcedMaterial(RgbColor(0,0,1));
-		ExportViewCellGeometry(exporter, testPrVs.mViewCell);
-
-     	exporter->SetForcedMaterial(RgbColor(1,0,0));
-		exporter->ExportGeometry(objects);
-
-		delete exporter;
-	}
-}
-
-
-void VspBspViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
-													vector<MergeCandidate> &candidates)
-{	
-	cout << "collecting merge candidates ... " << endl;
-
-	if (mUseRaysForMerge)
-	{
-		mVspBspTree->CollectMergeCandidates(rays, candidates);
-	}
-	else
-	{
-		vector<BspLeaf *> leaves;
-		mVspBspTree->CollectLeaves(leaves);
-	
-		mVspBspTree->CollectMergeCandidates(leaves, candidates);
-	}
-
-	cout << "fininshed collecting candidates" << endl;
+		return NULL;
+
+	if (!mViewSpaceBox.IsInside(point))
+	  return NULL;
+
+	return mVspTree->GetViewCell(point, active);
+}
+
+
+void VspOspViewCellsManager::CreateMesh(ViewCell *vc)
+{
+	// matt: TODO
+	Mesh *mesh = MeshManager::GetSingleton()->CreateResource();
+	vc->SetMesh(mesh);
+}
+
+
+int VspOspViewCellsManager::CastBeam(Beam &beam)
+{
+	// matt: TODO
+	return 0;
+}
+
+
+void VspOspViewCellsManager::Finalize(ViewCell *viewCell, 
+									  const bool createMesh)
+{
+#if TODO
+	float area = 0;
+	float volume = 0;
+
+	ViewCellContainer leaves;
+	mViewCellsTree->CollectLeaves(viewCell, leaves);
+
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+    for (it = leaves.begin(); it != it_end; ++ it)
+	{
+		BspNodeGeometry geom;
+		BspLeaf *leaf = dynamic_cast<BspViewCell *>(*it)->mLeaf;
+		mVspBspTree->ConstructGeometry(leaf, geom);
+
+		const float lVol = geom.GetVolume();
+		const float lArea = geom.GetArea();
+
+		//(*it)->SetVolume(vol);
+		//(*it)->SetArea(area);
+
+		area += lArea;
+		volume += lVol;
+
+        CreateMesh(*it);
+	}
+
+	viewCell->SetVolume(volume);
+	viewCell->SetArea(area);
+#endif
+}
+	
+
+void VspOspViewCellsManager::PrepareLoadedViewCells()
+{
+	// TODO
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1021)
@@ -309,5 +309,5 @@
 	virtual bool IsLeaf() const = 0;
 
-	virtual int Type() const;
+	virtual int Type() const = 0;
 
 	/** Determines whether this node is a root
@@ -435,5 +435,5 @@
 	bool IsLeaf() const;
 	
-		virtual int Type() const;
+	int Type() const;
 
 	/** Returns pointer of view cell.
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 1021)
@@ -142,5 +142,5 @@
 }
 
-
+/*
 bool ObjectsInteriorDistribution::GenerateSample(SimpleRay &ray) const
 {
@@ -170,5 +170,5 @@
 
 	return true;
-}
+}*/
 
 }
